Debian Bug report logs - #577981
initramfs-tools: files in /etc/modprobe.d/ ignored (ie not copied) when building initramfs

version graph

Package: initramfs-tools; Maintainer for initramfs-tools is Debian kernel team <debian-kernel@lists.debian.org>; Source for initramfs-tools is src:initramfs-tools.

Reported by: Vincent Danjean <vdanjean@debian.org>

Date: Thu, 15 Apr 2010 19:00:02 UTC

Severity: important

Found in version initramfs-tools/0.94.4

Fixed in version initramfs-tools/0.95

Done: maximilian attems <maks@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#577981; Package initramfs-tools. (Thu, 15 Apr 2010 19:00:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Vincent Danjean <vdanjean@debian.org>:
New Bug report received and forwarded. Copy sent to Debian kernel team <debian-kernel@lists.debian.org>. (Thu, 15 Apr 2010 19:00:05 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Vincent Danjean <vdanjean@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: initramfs-tools: files in /etc/modprobe.d/ ignored (ie not copied) when building initramfs
Date: Thu, 15 Apr 2010 20:56:13 +0200
Package: initramfs-tools
Version: 0.94.4
Severity: grave

In lenny, packages does not have to add the .conf extension to files in
/etc/modprobe.d/
When installing initramfs-tools in a lenny system (for example to upgrade
the kernel and other related components before upgrading all the system),
the initrd does not contain any /etc/modprobe.d/ files.

[...]
Setting up initramfs-tools (0.94.4) ...
update-initramfs: deferring update (trigger activated)
[...]
Processing triggers for initramfs-tools ...
update-initramfs: Generating /boot/initrd.img-2.6.32-4-amd64
cp: cannot stat `/etc/modprobe.d/*.conf': No such file or directory
ran:/home/vdanjean#

Your fix to #506533 is too restrictive for squeeze (it will be ok after,
when all /etc/modprobe.d/ files will always have the .conf extension)

Note: I put the severity to grave to prevent the migration to testing as this
bug occurs at partial upgrades, even if the missing files generally do not have
grave consequences.

  Regards
    Vincent

-- Package-specific info:
-- /proc/cmdline
BOOT_IMAGE=/vmlinuz-2.6.32-4-amd64 root=/dev/mapper/eyak-root ro quiet

-- /proc/filesystems
	ext3
	fuseblk

-- lsmod
Module                  Size  Used by
tun                    10828  2 
binfmt_misc             6431  1 
ppdev                   5030  0 
lp                      7462  0 
parport                27938  2 ppdev,lp
sco                     7193  2 
bridge                 39598  0 
stp                     1440  1 bridge
bnep                    9411  2 
rfcomm                 29517  4 
l2cap                  24656  16 bnep,rfcomm
crc16                   1319  1 l2cap
uinput                  6376  1 
kvm_intel              37648  0 
kvm                   213228  1 kvm_intel
nfsd                  253862  11 
lockd                  57539  1 nfsd
nfs_acl                 2031  1 nfsd
auth_rpcgss            33476  1 nfsd
sunrpc                161121  10 nfsd,lockd,nfs_acl,auth_rpcgss
exportfs                3170  1 nfsd
acpi_cpufreq            5555  0 
cpufreq_conservative     5162  0 
cpufreq_stats           2659  0 
cpufreq_userspace       1992  0 
cpufreq_powersave        902  0 
microcode              21723  0 
fuse                   50110  1 
dm_crypt               10507  0 
coretemp                4213  0 
loop                   11783  0 
firewire_sbp2          11466  0 
snd_hda_codec_idt      42417  1 
snd_hda_intel          19683  1 
snd_hda_codec          54212  2 snd_hda_codec_idt,snd_hda_intel
snd_hwdep               5364  1 snd_hda_codec
snd_pcm_oss            32591  0 
snd_mixer_oss          12606  1 snd_pcm_oss
snd_pcm                60439  3 snd_hda_intel,snd_hda_codec,snd_pcm_oss
snd_seq_midi            4400  0 
snd_rawmidi            15483  1 snd_seq_midi
snd_seq_midi_event      4628  1 snd_seq_midi
arc4                    1274  2 
joydev                  8411  0 
ecb                     1841  2 
snd_seq                42817  3 snd_seq_midi,snd_seq_midi_event
snd_timer              15502  2 snd_pcm,snd_seq
snd_seq_device          4477  3 snd_seq_midi,snd_rawmidi,snd_seq
iwlagn                 71740  0 
btusb                   9785  2 
iwlcore                78213  1 iwlagn
pcmcia                 19426  0 
bluetooth              41795  9 sco,bnep,rfcomm,l2cap,btusb
snd                    46350  14 snd_hda_codec_idt,snd_hda_intel,snd_hda_codec,snd_hwdep,snd_pcm_oss,snd_mixer_oss,snd_pcm,snd_rawmidi,snd_seq,snd_timer,snd_seq_device
yenta_socket           19115  1 
led_class               2401  1 iwlcore
rsrc_nonstatic          7294  1 yenta_socket
soundcore               4598  1 snd
mac80211              136220  2 iwlagn,iwlcore
serio_raw               3752  0 
pcmcia_core            24070  3 pcmcia,yenta_socket,rsrc_nonstatic
cfg80211              101416  3 iwlagn,iwlcore,mac80211
snd_page_alloc          6217  2 snd_hda_intel,snd_pcm
i2c_i801                7798  0 
dell_laptop             1969  0 
rfkill                 13012  5 bluetooth,cfg80211,dell_laptop
evdev                   7336  25 
dcdbas                  5048  1 dell_laptop
psmouse                49505  0 
ac                      2192  0 
battery                 4998  0 
processor              30247  3 acpi_cpufreq
wmi                     4307  0 
pcspkr                  1699  0 
ext3                  106502  6 
jbd                    37069  1 ext3
mbcache                 4970  1 ext3
dm_mod                 53690  21 dm_crypt
sg                     18728  0 
sr_mod                 12602  0 
cdrom                  29399  1 sr_mod
sd_mod                 29689  4 
crc_t10dif              1276  1 sd_mod
ata_generic             2983  0 
ata_piix               20445  0 
ahci                   32070  3 
uhci_hcd               18505  0 
tg3                    95583  0 
firewire_ohci          19484  0 
firewire_core          36688  2 firewire_sbp2,firewire_ohci
crc_itu_t               1307  1 firewire_core
libphy                 13542  1 tg3
thermal                11674  0 
ehci_hcd               30722  0 
libata                132199  3 ata_generic,ata_piix,ahci
scsi_mod              121941  5 firewire_sbp2,sg,sr_mod,sd_mod,libata
usbcore               121767  4 btusb,uhci_hcd,ehci_hcd
nls_base                6377  1 usbcore
i915                  253184  2 
drm_kms_helper         20049  1 i915
i2c_algo_bit            4225  1 i915
button                  4634  1 i915
video                  17445  1 i915
thermal_sys            11878  3 processor,thermal,video
output                  1692  1 video
drm                   142263  3 i915,drm_kms_helper
i2c_core               15584  5 i2c_i801,i915,drm_kms_helper,i2c_algo_bit,drm

-- /etc/kernel-img.conf
# Kernel image management overrides
# See kernel-img.conf(5) for details
do_symlinks = yes
relative_links = yes
do_bootloader = no
do_bootfloppy = no
do_initrd = yes
link_in_boot = no
postinst_hook = update-grub
postrm_hook   = update-grub

-- /etc/initramfs-tools/initramfs.conf
MODULES=most
BUSYBOX=y
KEYMAP=n
COMPRESS=gzip
BOOT=local
DEVICE=eth0
NFSROOT=auto

-- /etc/crypttab
# <target name>	<source device>		<key file>	<options>
decrypt-private	/dev/mapper/eyak-private	none	luks,checkargs=ext3,noauto


-- System Information:
Debian Release: squeeze/sid
  APT prefers oldstable
  APT policy: (500, 'oldstable'), (500, 'unstable'), (500, 'testing'), (500, 'stable'), (1, 'experimental')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.32-4-amd64 (SMP w/2 CPU cores)
Locale: LANG=fr_FR.UTF-8, LC_CTYPE=fr_FR.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/bash

Versions of packages initramfs-tools depends on:
ii  cpio                         2.11-2      GNU cpio -- a program to manage ar
ii  findutils                    4.4.2-1     utilities for finding files--find,
ii  klibc-utils                  1.5.17-4    small utilities built with klibc f
ii  module-init-tools            3.12~pre2-2 tools for managing Linux kernel mo
ii  udev                         151-3       /dev/ and hotplug management daemo

Versions of packages initramfs-tools recommends:
ii  busybox                       1:1.15.3-1 Tiny utilities for small and embed

initramfs-tools suggests no packages.

-- no debconf information




Severity set to 'important' from 'grave' Request was from maximilian attems <maks@debian.org> to control@bugs.debian.org. (Thu, 15 Apr 2010 21:33:14 GMT) Full text and rfc822 format available.

Added tag(s) pending. Request was from maximilian attems <maks@debian.org> to control@bugs.debian.org. (Tue, 18 May 2010 03:06:05 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, pedrib@gmail.com, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#577981; Package initramfs-tools. (Wed, 19 May 2010 15:12:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Pedro R <pedrib@gmail.com>:
Extra info received and forwarded to list. Copy sent to pedrib@gmail.com, Debian kernel team <debian-kernel@lists.debian.org>. (Wed, 19 May 2010 15:12:07 GMT) Full text and rfc822 format available.

Message #14 received at 577981@bugs.debian.org (full text, mbox):

From: Pedro R <pedrib@gmail.com>
To: Debian Bug Tracking System <577981@bugs.debian.org>
Subject: Re: i have the same problem
Date: Wed, 19 May 2010 16:09:27 +0100
Package: initramfs-tools
Version: 0.94.4
Severity: normal

Hi,

I just noticed this exact same problem with today's update of initramfs-tools.

My USB audio card now loads before the internal, contrary to my
/etc/modprobe.d/ settings.

BTW, should the USB audio drivers really be included in the "most" modules?
I know most means the majority, but USB audio drivers? Doesn't make much sense
to me.

Regards,
Pedro



-- Package-specific info:
-- /proc/cmdline
root=/dev/mapper/vgroup-ROOT ro 

-- /proc/filesystems
	xfs
	ext3
	fuseblk

-- lsmod
Module                  Size  Used by
microcode               7870  0 
acpi_cpufreq            6415  1 
cpufreq_userspace       2208  0 
cpufreq_stats           3345  0 
binfmt_misc             7342  1 
vboxnetadp              4755  0 
vboxnetflt             11282  0 
vboxdrv              1762923  2 vboxnetadp,vboxnetflt
fuse                   65557  1 
ext3                  129310  1 
jbd                    53013  1 ext3
mbcache                 7422  1 ext3
tp_smapi               25330  0 
thinkpad_ec             5586  1 tp_smapi
loop                   15454  0 
snd_hda_codec_conexant    34017  1 
snd_hda_intel          22252  0 
snd_hda_codec          90595  2 snd_hda_codec_conexant,snd_hda_intel
snd_usb_caiaq          21707  1 
snd_hwdep               6234  1 snd_hda_codec
snd_pcm_oss            37625  0 
snd_mixer_oss          14868  1 snd_pcm_oss
arc4                    1345  2 
ecb                     1951  2 
snd_pcm                82006  4 snd_hda_intel,snd_hda_codec,snd_usb_caiaq,snd_pcm_oss
i915                  271691  2 
uvcvideo               58812  0 
i2c_i801                8631  0 
snd_seq_dummy           1590  0 
drm_kms_helper         29501  1 i915
snd_seq_oss            27580  0 
drm                   191084  3 i915,drm_kms_helper
videodev               40264  1 uvcvideo
snd_seq_midi            4940  0 
snd_rawmidi            21210  2 snd_usb_caiaq,snd_seq_midi
snd_seq_midi_event      6755  2 snd_seq_oss,snd_seq_midi
v4l1_compat            14337  2 uvcvideo,videodev
snd_seq                51917  6 snd_seq_dummy,snd_seq_oss,snd_seq_midi,snd_seq_midi_event
v4l2_compat_ioctl32    10426  1 videodev
snd_timer              20958  2 snd_pcm,snd_seq
snd_seq_device          6274  5 snd_seq_dummy,snd_seq_oss,snd_seq_midi,snd_rawmidi,snd_seq
iwlagn                119010  0 
i2c_algo_bit            5344  1 i915
thinkpad_acpi          64906  0 
i2c_core               23277  6 i915,i2c_i801,drm_kms_helper,drm,videodev,i2c_algo_bit
iwlcore               131798  1 iwlagn
led_class               3113  1 thinkpad_acpi
wmi                     7453  0 
nvram                   6673  1 thinkpad_acpi
psmouse                40055  0 
snd                    63541  15 snd_hda_codec_conexant,snd_hda_intel,snd_hda_codec,snd_usb_caiaq,snd_hwdep,snd_pcm_oss,snd_mixer_oss,snd_pcm,snd_seq_oss,snd_rawmidi,snd_seq,snd_timer,snd_seq_device
soundcore               7515  1 snd
evdev                   8859  14 
mac80211              157628  2 iwlagn,iwlcore
snd_page_alloc          8084  2 snd_hda_intel,snd_pcm
serio_raw               4336  0 
video                  19635  1 i915
output                  2215  1 video
intel_agp              29870  2 i915
agpgart                36041  2 drm,intel_agp
cfg80211              156780  3 iwlagn,iwlcore,mac80211
rfkill                 18217  2 thinkpad_acpi,cfg80211
processor              31188  3 acpi_cpufreq
button                  5582  1 i915
battery                 5972  0 
ac                      2286  0 
xfs                   520948  2 
exportfs                3914  1 xfs
sha256_generic          9847  2 
aes_x86_64              7784  2 
aes_generic            27319  1 aes_x86_64
cbc                     2697  1 
dm_crypt               12380  1 
dm_mod                 69417  12 dm_crypt
lzf                     2319  0 
lzo                     1349  0 
lzo_compress            2133  1 lzo
sg                     21874  0 
sr_mod                 14202  0 
cdrom                  37313  1 sr_mod
sd_mod                 35693  3 
crc_t10dif              1443  1 sd_mod
usbhid                 38167  0 
hid                    79989  1 usbhid
ahci                   38849  2 
libata                187250  1 ahci
uhci_hcd               22031  0 
thermal                12992  0 
thermal_sys            15622  3 video,processor,thermal
ehci_hcd               36684  0 
e1000e                131358  0 
scsi_mod              164620  4 sg,sr_mod,sd_mod,libata
usbcore               168929  6 snd_usb_caiaq,uvcvideo,usbhid,uhci_hcd,ehci_hcd
nls_base                8221  1 usbcore

-- /etc/kernel-img.conf
# Kernel image management overrides
# See kernel-img.conf(5) for details
do_symlinks = yes
do_bootloader = no
do_initrd = yes
link_in_boot = no
postinst_hook = update-grub
postrm_hook   = update-grub

-- /etc/initramfs-tools/initramfs.conf
MODULES=most
BUSYBOX=y
KEYMAP=n
COMPRESS=gzip
BOOT=local
DEVICE=eth0
NFSROOT=auto

-- /etc/crypttab
# <target name>	<source device>		<key file>	<options>
lvm		/dev/sda2		none		luks,retry=1


-- System Information:
Debian Release: squeeze/sid
  APT prefers testing
  APT policy: (700, 'testing'), (650, 'unstable'), (600, 'experimental'), (500, 'testing-proposed-updates')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.34-toi-a4dj (SMP w/2 CPU cores; PREEMPT)
Locale: LANG=en_GB.UTF-8, LC_CTYPE=en_GB.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/bash

Versions of packages initramfs-tools depends on:
ii  cpio                         2.11-4      GNU cpio -- a program to manage ar
ii  findutils                    4.4.2-1     utilities for finding files--find,
ii  klibc-utils                  1.5.18-1    small utilities built with klibc f
ii  module-init-tools            3.12~pre2-3 tools for managing Linux kernel mo
ii  udev                         154-1       /dev/ and hotplug management daemo

Versions of packages initramfs-tools recommends:
ii  busybox                       1:1.14.2-2 Tiny utilities for small and embed

initramfs-tools suggests no packages.

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#577981; Package initramfs-tools. (Wed, 19 May 2010 15:34:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to maximilian attems <max@stro.at>:
Extra info received and forwarded to list. Copy sent to Debian kernel team <debian-kernel@lists.debian.org>. (Wed, 19 May 2010 15:34:03 GMT) Full text and rfc822 format available.

Message #19 received at 577981@bugs.debian.org (full text, mbox):

From: maximilian attems <max@stro.at>
To: Pedro R <pedrib@gmail.com>, 577981@bugs.debian.org
Subject: Re: Bug#577981: i have the same problem
Date: Wed, 19 May 2010 17:11:45 +0200
On Wed, May 19, 2010 at 04:09:27PM +0100, Pedro R wrote:
> 
> Hi,
> 
> I just noticed this exact same problem with today's update of initramfs-tools.
> 
> My USB audio card now loads before the internal, contrary to my
> /etc/modprobe.d/ settings.

your modprobe config needs to end with .conf, upstream will soon
ignore any that doesn't.
 
> BTW, should the USB audio drivers really be included in the "most" modules?
> I know most means the majority, but USB audio drivers? Doesn't make much sense
> to me.

this is a separate story please reportbug it.
never seen this.

thank you.




Reply sent to maximilian attems <maks@debian.org>:
You have taken responsibility. (Sat, 29 May 2010 04:21:12 GMT) Full text and rfc822 format available.

Notification sent to Vincent Danjean <vdanjean@debian.org>:
Bug acknowledged by developer. (Sat, 29 May 2010 04:21:12 GMT) Full text and rfc822 format available.

Message #24 received at 577981-close@bugs.debian.org (full text, mbox):

From: maximilian attems <maks@debian.org>
To: 577981-close@bugs.debian.org
Subject: Bug#577981: fixed in initramfs-tools 0.95
Date: Sat, 29 May 2010 04:17:08 +0000
Source: initramfs-tools
Source-Version: 0.95

We believe that the bug you reported is fixed in the latest version of
initramfs-tools, which is due to be installed in the Debian FTP archive:

initramfs-tools_0.95.dsc
  to main/i/initramfs-tools/initramfs-tools_0.95.dsc
initramfs-tools_0.95.tar.gz
  to main/i/initramfs-tools/initramfs-tools_0.95.tar.gz
initramfs-tools_0.95_all.deb
  to main/i/initramfs-tools/initramfs-tools_0.95_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 577981@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
maximilian attems <maks@debian.org> (supplier of updated initramfs-tools package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Fri, 28 May 2010 17:22:56 -0700
Source: initramfs-tools
Binary: initramfs-tools
Architecture: source all
Version: 0.95
Distribution: unstable
Urgency: low
Maintainer: Debian kernel team <debian-kernel@lists.debian.org>
Changed-By: maximilian attems <maks@debian.org>
Description: 
 initramfs-tools - tools for generating an initramfs
Closes: 545728 566295 575766 577253 577981 579702
Changes: 
 initramfs-tools (0.95) unstable; urgency=low
 .
   [ maximilian attems ]
   * update TODO list.
   * hook-functions: refactor copy_exec.
   * mkinitramfs: check only once for existing ldd.
   * mkinitramfs: Use eventual TMPDIR definition.
   * mkinitramfs: guard against empty EXTRA_CONF.
   * update-initramfs: Use nounset.
   * mkinitramfs: Fix several unbound variables.
   * mkinitramfs: On verbose indicate what we rm.
   * bug script: include sizes of generated initramfs.
   * debian/script: add generated resume param to bug.
   * hook-functions: manual_add_modules simplify.
   * hook-functions: copy_modules_dir() small simplifications.
   * mkinitramfs.8: Fix wrong sourcing in boot script. (Closes: #545728)
   * initramfs-tools.8: Mention /scritps/functions.
   * initramfs-tools.8: cryptopts param gone.
   * initramfs-tools.8: document BOOTIF variable.
   * configure_networking(): work with empty DEVICE string.
     (Closes: #566295, #575766)
   * hook-functions: add hid-apple. (Closes: #577253)
   * Revert "mkinitramfs: only copy modprobe conf files". (Closes: #577981)
   * initramfs-tools: change license to GPL.
   * hook-functions: re-add hid-microsoft. (Closes: #577253)
   * initramfs-tools: drop outdated breaks.
   * debian/copyright: add boilerplate to keep lintian happy.
   * hook-functions: Fix copy_modules_dir().
 .
   [ Axel Beckert ]
   * mkinitramfs.8: Add information about $TMPDIR environment variable.
 .
   [ bert schulze ]
   * mkinitramfs: add LZO support.
   * mkinitramfs: use -9 for lzop.
 .
   [ Vagrant Cascadian ]
   * configure_networking: pxelinux BOOTIF fixes.
   * init: add BOOTIF bootarg.
 .
   [ Michael Prokop ]
   * Support booting from USB 3 xHCI-based controllers.
 .
   [ Claus Herwig ]
   * mkinitramfs: fix MODULES=dep on mylex raid devices (DAC960).
     (Closes: #579702)
Checksums-Sha1: 
 9216f73b02d3b5eb006e3260b75655a6da7c45de 922 initramfs-tools_0.95.dsc
 a690ae41f9d01ff63d9997a2dba0c94d19dcd0ac 73275 initramfs-tools_0.95.tar.gz
 e7baa9731d1f5f5e0ac6314d9e2e4d6f2fd74640 79950 initramfs-tools_0.95_all.deb
Checksums-Sha256: 
 7b8954fd0a8e075a38c5c33970b475bd6e9d1c2e4b6f2f81814461d37986ec56 922 initramfs-tools_0.95.dsc
 ceafb109d8cf6240e8c5ea22cd14122c268bee30236867cc43b06b8821d37514 73275 initramfs-tools_0.95.tar.gz
 a8cab85628b927a365d9194f29a2825c1943c21c7e49a1083b5105ce1f655976 79950 initramfs-tools_0.95_all.deb
Files: 
 6b6072a0e133472eba9a27d0b257a96b 922 utils optional initramfs-tools_0.95.dsc
 c43c28e9ff65b26563ccf43079fc3d03 73275 utils optional initramfs-tools_0.95.tar.gz
 1c7793dab0a318b0a2773188f3f41fae 79950 utils optional initramfs-tools_0.95_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iEYEARECAAYFAkwAX84ACgkQeW7Lc5tEHqiDYwCgz4kG/6PcZ8KZAzpUNAKPgmKb
iy4An2v7U7LwlGo0tSJKhdjCy0xS+bwQ
=v+rR
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Tue, 29 Jun 2010 07:40:09 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Mon Apr 21 13:10:16 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.